#!/usr/bin/python3

import urllib3
import urllib.parse
import ssl
import base64
import hashlib
import json
import io
import sys

if len(sys.argv) != 2:
    print('Usage: client.py <URL>')
    sys.exit(1)

url = sys.argv[1]
parsed = urllib.parse.urlparse(url)
if parsed.scheme != 'https':
    raise Exception('URL scheme is not https')

#context = ssl.create_default_context()
context = ssl._create_unverified_context()

hostname = parsed.hostname
port = parsed.port or 443

conn = urllib3.connection.VerifiedHTTPSConnection(hostname, port, ssl_context=context)
conn.set_cert()
conn.connect()

conn.sock.do_handshake()
server_certificate = conn.sock.getpeercert(True)
certificate_hash = hashlib.sha256(server_certificate).hexdigest()
certificate_digest = base64.b16decode(certificate_hash.upper())
application_data = b'tls-server-end-point:%s' % certificate_digest

print('Client tls-unique', base64.b16encode(conn.sock.get_channel_binding('tls-unique')))
print('Client tls-server-end-point', certificate_hash)

conn.request('GET', url)
re = conn.getresponse()
re = urllib3.HTTPResponse.from_httplib(re)
print('Repsonse from server', re.data)
